// General

KSFastSpringJavascriptInstalled = function() {
	return true;
}

KSFastSpringDisableClickDrag = function() {
	document.onmousedown = function(event) {
		if (event.target.tagName == 'DIV') {
			event.preventDefault();
		}
	}
}

// Form Filling
KSFastSpringSetTextInputValue_forId = function(textValue, identifier) {
	var inputElement = document.getElementById(identifier);
	if (inputElement != null) {
		inputElement.value = textValue;
	};
}


KSFastSpringSetRegion = function(region) {
	var countrySelectElement = document.getElementById('user:country');
	var countryCode = '';
	if (countrySelectElement != null) {
		countrySelectedIndex = countrySelectElement.selectedIndex;
		countryCode = countrySelectElement.options[countrySelectedIndex].value;
	}
	var regionSelectElement = document.getElementById('user:region');
	var regionInputElement = document.getElementById('user:region_custom');
	if (regionSelectElement != null) {
		var regionIndex = -1;
		var regionsCount = regionSelectElement.options.length;
		var likelyRegionValue = countryCode + '-' + region;
		for (var i = 0; i < regionsCount; i++) {
			var regionOption = regionSelectElement.options[i];
			if (regionOption.value == likelyRegionValue || regionOption.innerText == region)
				regionIndex = i;
		}
		if (regionIndex != -1)
			regionSelectElement.selectedIndex = regionIndex;
		return regionIndex;
	}
	else if (regionInputElement != null && regionInputElement.style.display != 'none') {
		regionInputElement.value = region;
	}
}

KSFastSpringSetCouponCodePlaceholder = function(placeholderText) {
	// We use jQuery here as the id of the text field has changed on us, so we use something more loose.
	$(".store-order-action-coupon input.store-action-input").each(function(index, element){
																  element.placeholder = placeholderText;
																  });


}

KSFastSpringCreatePlaceholdersFromLabels = function() {
	// Find all labels, get their for attribute, get the element it points to, and
	// set the placeholder for it to the text inside of the label.
	var labels = document.getElementsByTagName("LABEL");
	for (var i = 0; i < labels.length; i++)
	{
		var label = labels[i];
		var id = label.getAttribute("for");
		if (id != null)
		{
			var element = document.getElementById(id);
			if (element != null && element.tagName == "INPUT")
			{
				var placeholderText = label.innerText;
				if (id == "user:company")
				{
					// Special case for company, add (optional)
					placeholderText = placeholderText + " (optional)";
				}
				else if (id == "confirm:card_security_code")
				{
					// Special case for card security code, make it blank.
					placeholderText = "";
				}
				element.placeholder = placeholderText;
			}
		}
	}
	
	// Sepcial case for Region, as the label doesn't point to it.
	var regionElement = document.getElementById("user:region_custom");
	if (regionElement != null && regionElement.placeholder == "")
	{
		regionElement.placeholder = "Region";
	}
}

KSFastSpringCreateAlertsFromCoreMessages = function() {
	var messages = document.getElementsByClassName("core-messages");
	for (var i = 0; i < messages.length; i++)
	{
		var messageElement = messages[i];
		var messageList = [];
		var errorMessages = messageElement.getElementsByClassName("core-message-error");
		for (var j = 0; j < errorMessages.length; j++)
		{
			var errorMessage = errorMessages[j].innerText;
			errorMessage = errorMessage.replace(/(^\s+|\s+$)/g, ''); // trim
			if (errorMessage.length > 0)
				messageList.push(errorMessage);
		}
		if (messageList.length > 0)
		{
			var message = messageList.join("\n");
			alert(message);
		}
	}
	return messages;
}

// Cancel button for backing out of purchase window

KSFastSpringCreateCancelButton = function () {

	// Add a simple link that's similar to FastSpring's navigation butttons
	// Then call .button() on the <a> tag to turn it into a jquery-ui button to have
	// proper down states and such
	var aButtonInListElement = $('<li class="store-action-cancel-li"> <span class="store-action store-action-cancel"> <a id="bpxl-cancel-link" class="store-action-command" href="#" onclick="purchasingController.cancel(); return false;"> <span class="store-action-title">Cancel</span> </a> </span> </li>');
	$('.store-page-navigation').find('.store-action-list').append(aButtonInListElement);
	
	$("#bpxl-cancel-link").button();
}

// Function that sets things up so that we can get notified every time the country changes
// so that we can update the region from the address book
KSFastSpringStartObservingCountry = function() {
	// jquery doesn't like "#user:country" as a selector as it thinks the colon indicates a pseudo selector
	var countrySelectElement = document.getElementById('user:country');
	var regionSelectElement = document.getElementById('user:region');
	
	// Check when the country dropdown changes, which will cause either the region dropdown to change, or
	// disappear and be replaced with a text field.
	$(countrySelectElement).change( function() {
		purchasingController.countryDidChange();
	});
	
	// Check when the region dropdown has any of its options modified
	$(regionSelectElement).bind('DOMSubtreeModified', function () {
		purchasingController.countryDidChange();
	});
}
